#ifndef CALLBACKHANDLER_H_
#define CALLBACKHANDLER_H_




#include "jvmti.h"
#include "jni.h"
#include "TraceOutputter.h"


class CallBackHandler
{
public:
	CallBackHandler();
	CallBackHandler(jvmtiEnv *jvmti, TraceOutputter* traceOutputter);
	virtual ~CallBackHandler();
	
	virtual void nativeNewObj(JNIEnv *env, jclass klass, jobject thread, jobject o, bool isWeak);
	virtual void nativeNewObj(JNIEnv *env, jclass klass,
				  jobject thread, jint classId, jint allocSite, bool isWeak);
	virtual void nativeNewArray(JNIEnv *env, jclass klass, jobject thread, jobject o);
	virtual void nativeMethodEntry(JNIEnv *jni_env, jclass klass, jint methodId, jobject receiver);
	virtual void nativeMethodEntryStatic(JNIEnv *jni_env, jclass klass, jint methodId);
	virtual void nativeMethodExit(JNIEnv *jni_env, jclass klass, jint methodId, jobject receiver);
	virtual void nativeMethodException(JNIEnv *jni_env, jclass klass,
					   jobject exception, jint methodId, jobject receiver);
	virtual void nativeMethodExceptionStatic(JNIEnv *jni_env, jclass klass,
						 jobject exception, jint methodId);
	virtual void nativePointerMovedOff(JNIEnv *env, jclass klass, jobject oldTarget, jobject origin, jobject newTarget);
        virtual void syntheticPointerMovedOff(JNIEnv *jni, jclass klass, 
      					jlong oldTargetTag,
     					jlong originTag, jlong newTargetTag);

	virtual void nativeUninitPutfield(JNIEnv *env, jclass klass,
					  jobject newTarget, jint allocSite, jint fieldId);
	virtual void nativeInitOf(JNIEnv *env, jclass klass, jobject thread, jint allocSite);
	virtual void nativeArrayStore(JNIEnv *jni, jclass klass, jobject array, jint index, jobject storee);
	virtual void nativeVarEvent(JNIEnv *jni, jclass klass, jint numObjs, jobject o0, jobject o1, jobject o2, jobject o3, jobject o4);
	virtual void ObjectFree(jvmtiEnv *jvmti, jlong tag);
	virtual void GCStart(jvmtiEnv *jvmti);
	virtual void GCEnd(jvmtiEnv *jvmti);
	virtual void VMDeath(jvmtiEnv *jvmti);
	virtual void fakeAGC(jvmtiEnv *jvmti);
	virtual void VMInit(jvmtiEnv *jvmti, JNIEnv *jni, jthread thread);



	void VMObjectAlloc(jvmtiEnv *jvmti_env, JNIEnv* jni_env, jthread thread, jobject o, jclass object_klass, jlong size);
	
	//virtual  void cbVMStart(jvmtiEnv *jvmti, JNIEnv *env);
	//Do I want this here?
	//virtual void VMInit(jvmtiEnv *jvmti, JNIEnv *env, jthread thread);
};

#endif /*CALLBACKHANDLER_H_*/
