#ifndef EXTERNALCLASSINSTRUMENTER_H_
#define EXTERNALCLASSINSTRUMENTER_H_
#include "ClassInstrumenter.h"
#include <jni.h>
#include <jvmti.h>
#include <string>

using namespace std;

class ExternalClassInstrumenter : public ClassInstrumenter {
public:
  ExternalClassInstrumenter (jvmtiEnv *jvmti, string javapath, string classpath, string jarpath,
                             string useOpt, string outputFile, bool verbose, string experimental);
  virtual ~ExternalClassInstrumenter ();
  virtual void instrumentClass (jvmtiEnv *jvmti,
                                JNIEnv* env,
                                jclass class_being_redefined,
                                jobject loader,
                                const char* name,
                                jobject protection_domain,
                                jint class_data_len,
                                const unsigned char* class_data,
                                jint* new_class_data_len,
                                unsigned char** new_class_data);

private:
  string javapath;
  string jarpath;
  string classpath;
  string useOpt;
  string experimental;
  // void writeUntilDone(int fd, const unsigned char* buffer, int length);
  // int readUntilDone(int fd, int maxSize, unsigned char** returnBuffer);

  void writeUntilDone (int fd, const unsigned  char* buffer, int length);
  unsigned char *readUntilDone (jvmtiEnv *jvmti, int fd, int & length);

  unsigned int readSize (int fd);
  void writeSize (unsigned int size, int fd);
	
  void readFully (int fd, unsigned char * buffer, int length);
  void writeFully (int fd, const unsigned char * buffer, int length);

  jrawMonitorID lock;
  int childPid;
  int parentToChild[2];
  int childToParent[2];

};

#endif /*EXTERNALCLASSINSTRUMENTER_H_*/

// Local Variables:
// mode:C++
// c-basic-offset:2
// indent-tabs-mode:nil
// End:
