#ifndef GRAPHALGORITHMS_H_
#define GRAPHALGORITHMS_H_ 
#include <map>
#include <set>
#include <iostream>
#include "HashGraph.h"


using namespace std;


class GADiedBeforeComparator{
public:

  GADiedBeforeComparator(map<unsigned long, unsigned long>& o2t):
    oid2time(o2t)
  {
  }

  bool operator() (unsigned long obj1, unsigned long obj2){
    return oid2time[obj1] < oid2time[obj2];
  }
private:
  map<unsigned long, unsigned long>& oid2time;

};

map<long, set<long> >
computeDeathChunks(HashGraph g, vector<unsigned long> deadList, 
                   map<unsigned long, unsigned long>& tag2timeStamp);

void outPutDeathChunks(map<long,set<long> > causes, 
                       ostream& deathChunkFile, 
                       map<unsigned long, unsigned long>& tag2TimeStamp);

#endif
