#ifndef TRACEOUTPUTER_H_
#define TRACEOUTPUTER_H_
#include <jni.h>
#include <jvmti.h>
#include <string>

using namespace std;


class TraceOutputter
{
	
	
	
public:
	TraceOutputter();
	virtual ~TraceOutputter();
	
	virtual void doDeath(long tag, long deathTime);
	virtual void doAllocation(unsigned long time, int objectTag, jlong size, string type, unsigned long thread);
	#ifdef THREAD_TAG_UPDATES
	virtual void doPointerUpdate(unsigned long time, long oldTarget, long origin, long newTarget, long thread);
	#else
	virtual void doPointerUpdate(unsigned long time, long oldTarget, long origin, long newTarget);
	#endif
	virtual void doMethodEntry(unsigned long time, int methodId, /* string className, string methodName, string signature, */ unsigned long receiver, unsigned long thread);
	virtual void doMethodExit(unsigned long time, int methodId, /* string className, string methodName, string signature, */ unsigned long receiver,  unsigned long thread);
	virtual void doVarEvent(unsigned long time, unsigned long obj, unsigned long thread);
	virtual void doGCStart();
        virtual void doGCEnd();
        virtual void flush();
	virtual void doRoot(unsigned long time, unsigned long obj);
};

#endif /*TRACEOUTPUTER_H_*/
