#ifndef WEAKREFCLEANER_H_
#define WEAKREFCLEANER_H_

#include <vector>
#include <jvmti.h>
#include <jni.h>
#include <HashGraph.h>
#include "ETCallBackHandler.h"

using namespace std;

class ETCallBackHandler;
class WeakRefCleaner {

public:
  WeakRefCleaner (jvmtiEnv* jvmti, jrawMonitorID mon, ETCallBackHandler *etcbh);

  //Add a weak ref, to be cleaned up by the cleaner thread
  void addWeakRef (jvmtiEnv* jvmti, jweak obj);

  void cleanerThreadStart (jvmtiEnv* jvmti, JNIEnv* jni, HashGraph& theHeap);

private:
  jrawMonitorID weakCleanMon;
  jrawMonitorID weakRefListLock;
  set<jweak> weakRefs;
  jfieldID getReferentFieldID (jvmtiEnv* jvmti, JNIEnv* jni);
  jobject getObject (jvmtiEnv* jvmti, const long tag);
  vector<long> noLongerNeighbors(jvmtiEnv* jvmti, jobject obj, HashGraph& theHeap);
  ETCallBackHandler* etCallBackHandler;

};
#endif

// Local Variables:
// mode:C++
// c-basic-offset:2
// indent-tabs-mode:nil
// End:
